#!/usr/bin/perl

# Cambio de Clave de Usuario


use DBI;
my $db      = "isp";
my $host    = "localhost";
my $dbuser  = "isp";
my $dbpass  = "isp"; 
my $dbh		= DBI->connect("DBI:mysql:$db:$host", $dbuser, $dbpass);;
my $sth;                
my $rv;

use Radius;
my $radius = new Radius;
$radius->init('isp', 'isp', 'localhost', 'isp');
    
use CGI;
my $query       = new CGI;
my $cgi         = $query->url;
my $accion      = $query->param('accion') || 'Nada';

my $usuario		= $query->param('usuario');
my $claveA		= $query->param('clave');
my $claveN1		= $query->param('clave1');
my $claveN2		= $query->param('clave2');


print "Content-type: text/html\n\n";

if (! &UsuarioOK($usuario)) {

	redirect("/error/AdminISP/usuario_error.html");

} elsif (! &ClaveOK($usuario, $claveA)) {

	redirect("/error/AdminISP/clave_error.html");

} elsif ((! $claveN1) && (! $claveN2)) {

	redirect("/error/AdminISP/clavenueva_falta.html");

} elsif ($claveN1 ne $claveN2) {

	redirect("/error/AdminISP/clavenueva_error.html");

} else {

	$radius->update_user_attribute($usuario, "check", "Password", $claveA, $claveN1);
	$sth = $dbh->prepare("UPDATE dialup_users SET password=? WHERE username=?");
	$rv  = $sth->execute($claveN1, $usuario);
	redirect("/error/AdminISP/clavecambio_ok.html");

}




sub UsuarioOK {
	my $username = shift;
    return 1 if (   $radius->select_count('radreply',  {UserName => $username}) or
                    $radius->select_count('radcheck',  {UserName => $username}) or
                    $radius->select_count('usergroup', {UserName => $username}));
    return undef;
}



sub ClaveOK {
	my $username = shift;
	my $clave	 = shift;
	#$dbh = DBI->connect("DBI:mysql:$db:$host", $dbuser, $dbpass);
	$sth = $dbh->prepare("SELECT password FROM dialup_users WHERE username=?");
	$rv  = $sth->execute($username);
	my $claveR = $sth->fetchrow_array;
#
#print "<br>";
#print "$clave<br>";
#print "$claveR<br>";
	return 1 if ($clave eq $claveR);
	return undef;
}



sub redirect {
	my $url = shift;
	
	print "<script language=\"JavaScript\">";
    print "navigate(\"$url\");";
    print "</script>";
}


