#!/bin/sh

HOME=/usr/local/AdminISP

####

do_tables() {
	chkconfig --level 345 mysqld on
	service mysqld status 2&> /dev/null
	if [ ! "$?" = "0" ]; then 
		service mysqld start
	fi
	mysql < ${HOME}/install/CREATE_DB.sql >/dev/null 2>&1
	mysql --force isp < ${HOME}/install/CREATE_TABLES.sql >/dev/null 2>&1
	mysql isp < ${HOME}/install/FEED_TABLES.sql >/dev/null 2>&1
	mysql --force isp < ${HOME}/install/sql/actualizacion20061102.txt >/dev/null 2>&1
	mysql --force isp < ${HOME}/install/sql/actualizacion200802.txt >/dev/null 2>&1
	mysql --force isp < ${HOME}/install/sql/actualizacion20080505.txt >/dev/null 2>&1
	mysql --force isp < ${HOME}/install/sql/actualizacion20080805.txt >/dev/null 2>&1
	mysql --force isp < ${HOME}/install/sql/actualizacion20080825.txt >/dev/null 2>&1
	mysql --force isp < ${HOME}/install/sql/actualizacion20090421.txt >/dev/null 2>&1
	mysql --force isp < ${HOME}/install/sql/actualizacion20090812.txt >/dev/null 2>&1
	mysql --force isp < ${HOME}/install/sql/actualizacion20090831.txt >/dev/null 2>&1
	mysql --force isp < ${HOME}/install/sql/actualizacion20090922.txt >/dev/null 2>&1
	mysql --force isp < ${HOME}/install/sql/actualizacion20101001.txt >/dev/null 2>&1
	php -f ${HOME}/home/_updateips.php
}
#${HOME}/install/createloader.php
do_tables;
#Config
ln -f -s ${HOME}/etc/lighttpd/lighttpd.conf /etc/lighttpd/lighttpd.conf
ln -f -s ${HOME}/etc/init.d/AdminISPfw.init /etc/init.d/AdminISPfw
ln -f -s ${HOME}/etc/cron.d/checkservices /etc/cron.d/checkservices
ln -f -s ${HOME}/etc/cron.d/cambioconfig /etc/cron.d/cambioconfig
ln -f -s ${HOME}/etc/cron.d/graficos /etc/cron.d/graficos
mkdir -p /var/run/lighttpd >/dev/null 2>&1
chown lighttpd:lighttpd /var/run/lighttpd >/dev/null 2>&1
chkconfig --add AdminISPfw
chkconfig --level 345 AdminISPfw on
chkconfig --level 345 pmacct on
chkconfig --level 345 lighttpd on
service lighttpd restart >/dev/null 2>&1
exit 0
